質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.51%

Ruby on Rails 5 ImageMagickを読み込めない

受付中

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 1,770

hiraisodai

score 4

 前提・実現したいこと

local環境でrails tutorialのsample appを作っています。
第13章の画像をリサイズする箇所でエラーが出てしまいました。
どなたか、何か手掛かりが分かる方がいらっしゃれば、お助けお願い致します。

 発生している問題・エラーメッセージ

画像をリサイズするために、gemのcarrierwaveとmini_magick、production環境にfogをインストールした後に、mini_magickに必要なImageMagickをインストールしました。
しかし、フォームから画像と共に投稿をアップロードしようとすると以下のようなエラーが出てしまいます。

投稿前

投稿前

投稿後

投稿後

 該当のソースコード

Gemfile

source 'https://rubygems.org'


gem 'bootsnap'
gem 'rails',        '5.2.1'
gem 'faker',          '1.7.3'
gem 'carrierwave',             '1.2.3'#carrierwaveとmini_magickだけ最新のversionに変えました
gem 'mini_magick',             '4.9.2' 
gem 'will_paginate',          '3.1.6'
gem 'bootstrap-will_paginate', '1.0.0'
gem 'bcrypt',         '3.1.12'
gem 'bootstrap-sass', '3.3.7'
gem 'puma',         '3.9.1'
gem 'sass-rails',   '5.0.6'
gem 'uglifier',     '3.2.0'
gem 'coffee-rails', '4.2.2'
gem 'jquery-rails', '4.3.1'
gem 'turbolinks',   '5.0.1'
gem 'jbuilder',     '2.7.0'

group :development, :test do
  gem 'sqlite3', '1.3.13'
  gem 'byebug',  '9.0.6', platform: :mri
end

group :development do
  gem 'web-console',           '3.5.1'
  gem 'listen',                '3.1.5'
  gem 'spring',                '2.0.2'
  gem 'spring-watcher-listen', '2.0.1'
end

group :test do
  gem 'rails-controller-testing', '1.0.2'
  gem 'minitest',                 '5.10.3'
  gem 'minitest-reporters',       '1.1.14'
  gem 'guard',                    '2.13.0'
  gem 'guard-minitest',           '2.4.4'
  gem 'win32console'
end

group :production do
  gem 'pg', '0.20.0'
  gem 'fog', '1.42'
end

# Windows環境ではtzinfo-dataというgemを含める必要があります
gem 'tzinfo-data', platforms: [:mingw, :mswin, :x64_mingw, :jruby]


picture_uploader.rb

class PictureUploader < CarrierWave::Uploader::Base
  # Include RMagick or MiniMagick support:
  #include CarrierWave::RMagick
  include CarrierWave::MiniMagick
  process resize_to_limit: [400, 400]

  # Choose what kind of storage to use for this uploader:
  if Rails.env.production?
    storage :fog
  else
    storage :file
  end
  # storage :fog

  # Override the directory where uploaded files will be stored.
  # This is a sensible default for uploaders that are meant to be mounted:
  def store_dir
    "uploads/#{model.class.to_s.underscore}/#{mounted_as}/#{model.id}"
  end

  # Provide a default URL as a default if there hasn't been a file uploaded:
  # def default_url(*args)
  #   # For Rails 3.1+ asset pipeline compatibility:
  #   # ActionController::Base.helpers.asset_path("fallback/" + [version_name, "default.png"].compact.join('_'))
  #
  #   "/images/fallback/" + [version_name, "default.png"].compact.join('_')
  # end

  # Process files as they are uploaded:
  # process scale: [200, 300]
  #
  # def scale(width, height)
  #   # do something
  # end

  # Create different versions of your uploaded files:
  # version :thumb do
  #   process resize_to_fit: [50, 50]
  # end

  # Add a white list of extensions which are allowed to be uploaded.
  # For images you might use something like this:
  def extension_whitelist
     %w(jpg jpeg gif png)
  end

  # Override the filename of the uploaded files:
  # Avoid using model.id or version_name here, see uploader/store.rb for details.
  # def filename
  #   "something.jpg" if original_filename
  # end
end

 試したこと

Imagemagickがインストールされているか確認するために、コマンド上でmagick --versionを試しましたが、しっかりインストールされているようでした。

コマンドプロンプト上で出た表示

C:\Users\souda\environment\twitter_like_app>magick --version
Version: ImageMagick 7.0.8-12 Q16 x64 2018-09-23 http://www.imagemagick.org
Copyright: Copyright (C) 1999-2018 ImageMagick Studio LLC
License: http://www.imagemagick.org/script/license.php
Visual C++: 180040629
Features: Cipher DPC Modules OpenMP
Delegates (built-in): bzlib cairo flif freetype gslib heic jng jp2 jpeg lcms lqr lzma openexr pangocairo png ps raw rsvg tiff webp xml zlib


環境変数のpath設定は以下のようになっています。
これは、ImageMagickをインストールした時に自動で設定されました。

C:\Program Files\ImageMagick-7.0.8-Q16

 補足情報(FW/ツールのバージョンなど)

pc:windows10
rails:Rails 5.2.1
ruby:ruby 2.4.4

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

0

こちらを参考にしてImageMagickのバージョン7以前のコマンドが使えるようにしてはどうですか?

【ImageMagick】convertコマンドが使えない。見つからない。
以下引用

インストーラー(*.exe)を実行し、手順を進めると、以下のようなダイアログ(Select Additional Tasks)が表示される。初期状態では、上から4つめのチェックボックス(Install legacy utilities (e.g. convert))がオフになっている。これをオンにして、手順を進めると、convertコマンドがインストールされるようになる。

公式ページ(http://www.imagemagick.org/)を開き、画面最上部の左から2つめに「Download」があるのでそれをクリック。
下部に「Windows Binary Release」とある。そこからダウンロードする。64ビット版のダイナミック版(ImageMagick-7.0.5-4-Q16-x64-dll.exe)でよい。ダウンロードはHTTPでもFTPでもかまわない(HTTPが無難)。そのファイルのところのdownloadの文字をクリックしてファイル(インストーラー)をダウンロードする。
インストーラーを実行する。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.51%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる